VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FilePathInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Special Filepaths
'
' 29 September 2001
' 09 March 2002 - Update for Windows 2000/XP
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' Class Usage:
'
' Dim PathInfo As New FilePathInfo
' MsgBox "Windows path is " & PathInfo.WinDir()
' etc...
'
'------------------------------------------------------------------




'------------------------------------------------------------------
' Compiler Directives

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5


'------------------------------------------------------------------
' API Declarations


Private Const ERROR_SUCCESS = 0

' Str is unicode
Private Const IS_TEXT_UNICODE_ASCII16 = &H1
Private Const IS_TEXT_UNICODE_REVERSE_ASCII16 = &H10
Private Const IS_TEXT_UNICODE_STATISTICS = &H2
Private Const IS_TEXT_UNICODE_REVERSE_STATISTICS = &H20
Private Const IS_TEXT_UNICODE_CONTROLS = &H4
Private Const IS_TEXT_UNICODE_REVERSE_CONTROLS = &H40
Private Const IS_TEXT_UNICODE_SIGNATURE = &H8
Private Const IS_TEXT_UNICODE_REVERSE_SIGNATURE = &H80
Private Const IS_TEXT_UNICODE_ILLEGAL_CHARS = &H100
Private Const IS_TEXT_UNICODE_ODD_LENGTH = &H200
Private Const IS_TEXT_UNICODE_DBCS_LEADBYTE = &H400
Private Const IS_TEXT_UNICODE_NULL_BYTES = &H1000
Private Const IS_TEXT_UNICODE_UNICODE_MASK = &HF
Private Const IS_TEXT_UNICODE_REVERSE_MASK = &HF0
Private Const IS_TEXT_UNICODE_NOT_UNICODE_MASK = &HF00
Private Const IS_TEXT_UNICODE_NOT_ASCII_MASK = &HF000
Private Declare Function IsTextUnicode Lib "advapi32" (lpBuffer As Any, ByVal cb As Long, lpi As Long) As Long

' Directories
Public Enum FileSpecialFolders
  CSIDL_DESKTOP = &H0                            ' <desktop>
  CSIDL_INTERNET = &H1                           ' Internet Explorer (icon on desktop)
  CSIDL_PROGRAMS = &H2                           ' Start Menu\Programs
  CSIDL_CONTROLS = &H3                           ' My Computer\Control Panel
  CSIDL_PRINTERS = &H4                           ' My Computer\Printers
  CSIDL_PERSONAL = &H5                           ' My Documents
  CSIDL_FAVORITES = &H6                          ' <user name>\Favorites
  CSIDL_STARTUP = &H7                            ' Start Menu\Programs\Startup
  CSIDL_RECENT = &H8                             ' <user name>\Recent
  CSIDL_SENDTO = &H9                             ' <user name>\SendTo
  CSIDL_BITBUCKET = &HA                          ' <desktop>\Recycle Bin
  CSIDL_STARTMENU = &HB                          ' <user name>\Start Menu
  CSIDL_MYDOCUMENTS = &HC                        ' logical "My Documents" desktop icon
  CSIDL_MYMUSIC = &HD                            ' "My Music" folder
  CSIDL_MYVIDEO = &HE                            ' "My Videos" folder
  CSIDL_DESKTOPDIRECTORY = &H10                  ' <user name>\Desktop
  CSIDL_DRIVES = &H11                            ' My Computer
  CSIDL_NETWORK = &H12                           ' Network Neighborhood
  CSIDL_NETHOOD = &H13                           ' <user name>\nethood
  CSIDL_FONTS = &H14                             ' windows\fonts
  CSIDL_TEMPLATES = &H15
  CSIDL_COMMON_STARTMENU = &H16                  ' All Users\Start Menu
  CSIDL_COMMON_PROGRAMS = &H17                   ' All Users\Programs
  CSIDL_COMMON_STARTUP = &H18                    ' All Users\Startup
  CSIDL_COMMON_DESKTOPDIRECTORY = &H19           ' All Users\Desktop
  CSIDL_APPDATA = &H1A                           ' <user name>\Application Data
  CSIDL_PRINTHOOD = &H1B                         ' <user name>\PrintHood
  CSIDL_LOCAL_APPDATA = &H1C                     ' <user name>\Local Settings\Applicaiton Data (non roaming)
  CSIDL_ALTSTARTUP = &H1D                        ' non localized startup
  CSIDL_COMMON_ALTSTARTUP = &H1E                 ' non localized common startup
  CSIDL_COMMON_FAVORITES = &H1F
  
#If IE401 >= IE401 Then
  CSIDL_INTERNET_CACHE = &H20
  CSIDL_COOKIES = &H21
  CSIDL_HISTORY = &H22
#End If
  
#If WIN32_IE >= IE5 Then
  CSIDL_COMMON_APPDATA = &H23                    ' All Users\Application Data
  CSIDL_WINDOWS = &H24                           ' GetWindowsDirectory()
  CSIDL_SYSTEM = &H25                            ' GetSystemDirectory()
  CSIDL_PROGRAM_FILES = &H26                     ' C:\Program Files
  CSIDL_MYPICTURES = &H27                        ' C:\Program Files\My Pictures
  CSIDL_PROFILE = &H28                           ' USERPROFILE
  CSIDL_SYSTEMX86 = &H29                         ' x86 system directory on RISC
  CSIDL_PROGRAM_FILESX86 = &H2A                  ' x86 C:\Program Files on RISC
  CSIDL_PROGRAM_FILES_COMMON = &H2B              ' C:\Program Files\Common
  CSIDL_PROGRAM_FILES_COMMONX86 = &H2C           ' x86 Program Files\Common on RISC
  CSIDL_COMMON_TEMPLATES = &H2D                  ' All Users\Templates
  CSIDL_COMMON_DOCUMENTS = &H2E                  ' All Users\Documents
  CSIDL_COMMON_ADMINTOOLS = &H2F                 ' All Users\Start Menu\Programs\Administrative Tools
  CSIDL_ADMINTOOLS = &H30                        ' <user name>\Start Menu\Programs\Administrative Tools
  CSIDL_CONNECTIONS = &H31                       ' Network and Dial-up Connections

  CSIDL_FLAG_CREATE = &H8000                     ' combine with CSIDL_ value to force folder creation in SHGetFolderPath()
  CSIDL_FLAG_DONT_VERIFY = &H4000                ' combine with CSIDL_ value to return an unverified folder path
  CSIDL_FLAG_NO_ALIAS = &H1000                   ' combine with CSIDL_ value to insure non-alias versions of the pidl
  CSIDL_FLAG_MASK = &HFF00                       ' mask for all possible flag values

#End If
End Enum

Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)



'------------------------------------------------------------------
' Get the Paths

Public Property Get WinDir() As String
  Dim RetVal As Long
  Dim Buffer As String
  Buffer = String$(255, 0)
  RetVal = GetWindowsDirectory(Buffer, Len(Buffer))
  WinDir = Left(Buffer, RetVal)
  WinDir = WinDir & IIf(Right(WinDir, 1) = "\", "", "\")
End Property

Public Property Let WinDir(NewValue As String)
  Error 383
End Property

Public Property Get SystemDir() As String
  Dim RetVal As Long
  Dim Buffer As String
  Buffer = String$(255, 0)
  RetVal = GetSystemDirectory(Buffer, Len(Buffer))
  SystemDir = Left(Buffer, RetVal)
  SystemDir = SystemDir & IIf(Right(SystemDir, 1) = "\", "", "\")
End Property

Public Property Let SystemDir(NewValue As String)
  Error 383
End Property

Public Property Get TempDir() As String
  Dim TxtLen As Integer
  Dim Buffer As String
  TxtLen = 200
  Buffer = Space(TxtLen)
  TxtLen = GetTempPath(TxtLen, Buffer)
  If TxtLen Then TempDir = Left(Buffer, TxtLen)
End Property

Public Property Get SpecialFolder(Folder As FileSpecialFolders, Optional hWnd As Long) As String
  Dim pidl As Long
  Dim Pos As Long
  Dim Path As String
   
  'fill the pidl with the specified folder item
  If SHGetSpecialFolderLocation(hWnd, Folder, pidl) = ERROR_SUCCESS Then
    'initialize & get the path
    Path = Space(260)
    
    If SHGetPathFromIDList(ByVal pidl, ByVal Path) Then
      SpecialFolder = CStrFromStrZ(Path)
      If Right(SpecialFolder, 1) <> "\" Then SpecialFolder = SpecialFolder & "\"
      Call CoTaskMemFree(pidl)
    End If
  End If
End Property

Private Function CStrFromStrZ(szStr As String) As String
  ' Returns string before first null char encountered (if any)
  ' from either an ANSII or Unicode string buffer.
  
  If StrIsUnicode(szStr) Then szStr = StrConv(szStr, vbFromUnicode)
  If InStr(szStr, vbNullChar) Then
    CStrFromStrZ = Left(szStr, InStr(szStr, vbNullChar) - 1)
  Else
    CStrFromStrZ = szStr
  End If
End Function

Private Function StrIsUnicode(sBuffer As String) As Boolean
  ' Returns True if sBuffer evaluates to a Unicode string
  Dim dwRtnFlags As Long
  dwRtnFlags = IS_TEXT_UNICODE_UNICODE_MASK
  StrIsUnicode = IsTextUnicode(ByVal sBuffer, Len(sBuffer), dwRtnFlags)
End Function

