Attribute VB_Name = "Global_Fileroutines"
Option Explicit

'==================================================================
'
' File Routines
' These routines can be copied into your other programs
'
' 29 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



'------------------------------------------------------------------
' API Declarations

Private Const MAX_PATH = 260

Private Const TF_FORCEDRIVE = &H80
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetFileTitle Lib "comdlg32" Alias "GetFileTitleA" (ByVal szFile As String, ByVal szTitle As String, ByVal cbBuf As Long) As Long


'------------------------------------------------------------------
' File/Path functions

Public Function FileExist(ByVal FileName As String, Optional TestRelPathToo As Boolean = True) As Boolean
  If Len(Trim(FileName)) Then
    FileExist = CBool(Len(Dir(FileName)))
    If Not FileExist And TestRelPathToo Then
      FileName = CurDir() & IIf((Right(CurDir(), 1) <> "\" And Left(FileName, 1) <> "\"), "\", "") & FileName
      FileExist = CBool(Len(Dir(FileName)))
    End If
  End If
End Function

Public Function FileMakeMaxPath(ByVal FileName As String) As String
  ' Terminates sPath w/ null chars making
  ' the return string MAX_PATH chars long.
  FileMakeMaxPath = FileName & String(MAX_PATH - Len(FileName), 0)
End Function


'------------------------------------------------------------------
' Get Elements from a file

Public Function FileParsePath(ByVal FileName As String) As String
  ' Returns everything before last "\"
  Dim Pos As Long
  Do
    Pos = InStr(Pos + 1, FileName, "\")
    If Pos Then
      FileParsePath = Left(FileName, Pos)
    End If
  Loop While Pos
End Function

Function FileParseFileName(ByVal FileName As String) As String
  Dim RetVal As String
  Dim RetLen As Integer
  
  RetVal = String(MAX_PATH, 0)
  If GetFileTitle(FileName, RetVal, Len(RetVal)) = 0 Then
    FileParseFileName = Left(RetVal, InStr(RetVal, vbNullChar) - 1)
  End If
End Function


'------------------------------------------------------------------
' Make a Temp Filename

Public Function FileMakeTempName(Prefix As String, Optional ByVal Path As String) As String
  Dim TempDrive As Integer
  Dim TempFile As String
  
  If Path = "" Then Path = CurDir()
  Path = Path & IIf(Right(Path, 1) = "\", "", "\")
  TempFile = Space(144)
  If GetTempFileName(Path, Prefix, 0, TempFile) Then
    FileMakeTempName = Left(TempFile, InStr(1, TempFile, vbNullChar) - 1)
  Else
    Err.Raise 12345, "Temp File", "Could not make unique name for temp file!"
  End If
End Function

